#!perl
use warnings;
use strict;

package Example::Object_oriented;

sub new {
	
	# This creates the refernece which is going
	# to be our object
	my $hashref = {};
	
	# We then call bless to associate it with
	# this module.
	bless $hashref;
	
	# Finally we return it so the calling program
	# can start using it.
	return $hashref;
	
}

sub save_value {

	# This subroutine takes a single arguement
	# which it stores in the hash reference.
	#
	# The $object is provided automatically as
	# the first argument to every object oriented
	# subroutine (other than 'new').
	
	my ($object,$new_value) = @_;
	
	$object->{value} = $new_value;
	
}

sub get_value {
	
	# This subroutine retrieves a value which was previously
	# stored via the save_value subroutine.  If there isn't
	# a value to retrieve it returns the undefined value.
	
	my ($object) = @_;
	
	if (exists $object->{value}) {
		return $object->{value};
	}
	else {
		return undef;
	}
	
}

1;

