#!c:/perl/bin/perl.exe
use warnings;
use strict;
use diagnostics;
use List::Util qw(shuffle);
use Text::Wrap qw(wrap $columns);

$columns = 80;

my $original = <<'END_ORIGINAL';
According to research at an English University, it doesn't matter in
what order the letters in a word are, the only important thing is that
the first and and last letter is at the right place.  The rest can be a
total mess and you can still read it without problem.  This is because
we do not read every letter by itself but the word as a whole.
END_ORIGINAL

$original =~ s/\b(\w+)\b/rearrange($1)/eg;

$original =~ s/\n/ /g;

print wrap("","",$original);


sub rearrange {
	my ($letters) = @_;
	
	return $letters if (length($letters)<4);
	
	my @letters = split(//,$letters);
	@letters = ($letters[0],shuffle(@letters[1..$#letters-1]),$letters[$#letters]);
	
	my $mixed = join("",@letters);
	
	# Check we have actually mixed it up
	if ($letters eq $mixed) {
		return (rearrange($letters));
	}
	else {
		return $mixed;
	}

}